# converts log - files by gmxtlaunch to gpx
# convert all found log - files in dir

import os, datetime, time, glob

logfiles=u"E:\\gmxt_log\\*.log"
#logfiles=u"c:\\_home\\_xdevel-lokal\\gmxtlaunch3-2\\*.log" # for testing
count = 0
usedheader = 0


usedheader=1
exportfile = u"E:\\gmxt_log\\"+time.strftime("%y-%m-%d")+"-export.gpx"
#exportfile = u"c:\\_home\\_xdevel-lokal\\gmxtlaunch3-2\\"+time.strftime("%y-%m-%d")+"-export.gpx"
print exportfile

export = open(exportfile, "w")

ntime=time.strftime("%Y-%m-%dT%H:%M:%SZ")

export.write(u'<?xml version="1.0" encoding="UTF-8" standalone="no" ?>\n')
export.write(u'<gpx xmlns="http://www.topografix.com/GPX/1/1" xmlns:gpxx="http://www.garmin.com/xmlschemas/GpxExtensions/v3" creator="Mobile XT for Symbian" version="1.1" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd http://www.garmin.com/xmlschemas/GpxExtensions/v3 http://www.garmin.com/xmlschemas/GpxExtensions/v3/GpxExtensionsv3.xsd">\n')
export.write(u'  <metadata>\n')
export.write(u'    <link href="http://www.garmin.com">\n')
export.write(u'      <text>Garmin International</text>\n')
export.write(u'    </link>\n')
export.write(u'    <time>'+ntime+'</time>\n')
export.write(u'  </metadata>\n')


for logfile in glob.glob(logfiles):
    print logfile+":"
    count = 0
    try:
        thisfile = file (logfile)
        while True:
            line = thisfile.readline()
            if len(line) == 0: 
                if count > 0:
                    # track end
                    export.write(u'  </trkseg>\n</trk>\n')

                thisfile.close()
                break

            count = count + 1
            line = line.split(";")

            time=line[0]
            lat=line[1]
            lon=line[2]
            ele=line[3].replace('\n','')
            ##print time, lat, lon, ele

            time2=str(datetime.datetime.fromtimestamp(float(time)))
            time2=time2.split(" ")
            time=time2[0]+"T"+time2[1]+"Z"

            if count == 1:
                # track start
                name=os.path.basename(logfile).split(".")[0]
                export.write(u'<trk>\n')
                export.write(u'  <name>'+name+'</name>\n')
                export.write(u'  <trkseg>\n')

            export.write(u'    <trkpt lat="'+lat+'" lon="'+lon+'">\n')
            export.write(u'      <ele>'+ele+'</ele>\n')
            export.write(u'      <time>'+time+'</time>\n')
            export.write(u'    </trkpt>\n')

        print "found "+str(count)+" trackpoints"
    except:
        print "!!!!cant use!!!!"
        

export.write(u'</gpx>\n')
export.close()
